#ifndef GLWIDGET_H
#define GLWIDGET_H

class QOpenGLShaderProgram;
class QOpenGLBuffer;
class QOpenGLTexture;

#include <QMatrix4x4>
#include <QOpenGLWidget>

class GLWidget : public QOpenGLWidget {
public:
    explicit GLWidget(QWidget *parent = 0);
    ~GLWidget();

private:
    QOpenGLShaderProgram * m_program;
    QOpenGLBuffer * m_IBO;
    QOpenGLBuffer * m_vertexDataVBO;
    QOpenGLTexture * m_texture;
    QMatrix4x4 m_matrix;

    GLuint m_matrixPos;
    GLuint m_texturePos;
    GLuint m_vertexPos;
    GLuint m_texCoordPos;

    bool m_isRotating;

    void initializeGL();
    void resizeGL(int w, int h);
    void paintGL();
    void timerEvent( QTimerEvent * event);
    void mousePressEvent( QMouseEvent * event );
    QImage drawImage(const QString &txt);
};

#endif // GLWIDGET_H
